<script>
import { mapState } from 'vuex';

export default {
  name: `user-dropdown`,
  computed: {
    ...mapState({
      username: (state) => state.users.currentUser.username,
    }),
  },
  methods: {
    switchTheme() {
      this.$vuetify.theme.dark = !this.$vuetify.theme.dark;
    },
    switchLanguage() {
      const lang = this.$i18n.locale === "en" ? "fr" : "en";
      this.$i18n.locale = lang;
      localStorage.setItem("preferredlanguage", lang);
    },
    logOut() {
      this.$store.dispatch(`websockets/clearPool`);
      const url = `${window.location.origin}/logout`;
      window.location.assign(url);
    }
  }
}
</script>

<template>
  <div @click="showTooltip = !showTooltip">
    <v-menu offset-y :nudge-bottom="4">
      <template v-slot:activator="{ on, attrs }">
        <v-btn icon v-bind="attrs" v-on="on">
          <v-icon>mdi-account</v-icon>
        </v-btn>
      </template>
      <v-list dense class="text-xs">
        <v-list-item>
          <v-list-item-title>
            {{ username }}
          </v-list-item-title>
        </v-list-item>
        <v-list-item-group>
          <v-list-item @click="switchTheme">
            <v-list-item-title>
              <v-icon small class="mr-2">mdi-brightness-6</v-icon>
              {{ $t("app-bar.switch-theme") }}
            </v-list-item-title>
          </v-list-item>
          <v-list-item @click="switchLanguage">
            <v-list-item-title>
              <v-icon small class="mr-2">mdi-translate</v-icon>
              {{ $t("app-bar.switch-language") }}
            </v-list-item-title>
          </v-list-item>
          <v-list-item @click="logOut">
            <v-list-item-title>
              <v-icon small class="mr-2">mdi-logout-variant</v-icon>
              {{ $t("app-bar.log-out") }}
            </v-list-item-title>
          </v-list-item>
        </v-list-item-group>
      </v-list>
    </v-menu>
  </div>
</template>
